(***************************************************************************

Miscellaneous formatting functions

VerifiCard Project - Dmons research team - LRI - Universit Paris XI

$Id: format_misc.ml,v 1.2 2003/01/23 15:58:48 urbain Exp $

***************************************************************************)

open Format;;

let fprintf_string form s = fprintf form "%s" s;;

let fprintf_option fpr form o =
  match o with
    | None -> fprintf form "None"
    | Some(x) -> fprintf form "@[<hv 1>Some@,(%a)@]" fpr x
;;

let rec fprintf_endlist fpr form l =
  match l with
    | [] -> fprintf form "]@]"
    | h::t -> 
	fprintf form ";@ %a" fpr h;
	fprintf_endlist fpr form t
;;

let fprintf_list fpr form l =
  match l with
    | [] -> fprintf form "[]"
    | h::t -> 
	fprintf form "@[<hv 2>[ %a" fpr h;
	fprintf_endlist fpr form t
;;
