
Section Map.

Set Implicit Arguments.
Unset Strict Implicit.

Variables I V : Set.
Variable eq_I_dec : forall i1 i2:I, {i1 = i2} + {i1 <> i2}.

Definition t := I -> V.

Definition cte (v:V) : t := fun i => v.

Definition find (x:t) : I -> V := x.
Definition add (m:t) (i:I) (v:V) : t :=
  fun i' => if eq_I_dec i i' then v else m i'.

Lemma find_add : forall (m:t) (i:I) (v:V), find (add m i v) i = v.
Proof.
unfold find, add in |- *; intros.
case (eq_I_dec i i); intros; auto.
case n; trivial.
Qed.

Lemma find_add_eq :
 forall (m:t) (i i':I) (v:V), i = i' -> find (add m i v) i' = v.
Proof.
simple destruct 1; apply find_add.
Qed.

Lemma find_add_other :
 forall (m:t) (i i':I) (v:V), i <> i' -> find (add m i v) i' = m i'.
Proof.
unfold find, add in |- *; intros.
case (eq_I_dec i i'); intros; auto.
case H; trivial.
Qed.

End Map.
Implicit Arguments cte [V].
