

exception Java_parse_error;;

let parse f = 
  Java_parser_base.cur_base := Location.init f;
  let c = open_in f in
  let lb = Lexing.from_channel c in
  try
    let a = Java_parser.compilation_unit Java_lexer.token lb in
(*i
    printf "************** AST OF %s ******************@." f;
    Ast.printf_compilation_unit a;
    printf "@.";
    printf "************** END OF AST *************************@.";
i*)
    close_in c;
    a
  with e -> 
    let (f,l) = (Lexing.lexeme_start lb, Lexing.lexeme_end lb) in
    close_in c;
    let pos = Location.find !Java_parser_base.cur_base f l in
    Format.printf "%s" (Location.to_string pos);
    match e with
      | Java_lexer.Lexical_error msg -> 
	  Format.printf "lexical error: %s@." msg; 
	  if !Config.stop_on_error
	  then exit 1
	  else raise Java_parse_error
      | Parsing.Parse_error -> 
	  Format.printf "syntax error@.";
	  if !Config.stop_on_error
	  then exit 1
	  else raise Java_parse_error
      | _ -> Format.printf "unexpected error@."; raise e
;;

