

exception Jml_parse_error;;

let do_parse base parse_fun s =
  Jml_parser_base.cur_base := base;
  let b = Lexing.from_string s in
  try
    parse_fun Jml_lexer.next_token b
  with e -> 
    let (f,l) = (Lexing.lexeme_start b, Lexing.lexeme_end b) in
    let pos = Location.find !Jml_parser_base.cur_base f l in
    Format.printf "%s" (Location.to_string pos);
    match e with
      | Jml_lexer.Lexical_error msg -> 
	  Format.printf "lexical error in jml spec: %s@." msg; 
	  if !Config.stop_on_error
	  then exit 1
	  else raise Jml_parse_error
      | Parsing.Parse_error -> 
	  Format.printf "syntax error in jml spec@.";
	  if !Config.stop_on_error
	  then exit 1
	  else raise Jml_parse_error
      | _ -> 
	  Format.printf "unexpected error in jml spec@.";
	  if !Config.stop_on_error
	  then exit 1
	  else raise e



let parse_jml_specification loc s = 
  try
    do_parse loc Jml_parser.jml_specification_eof s
  with
    | Jml_parse_error -> Ast.default_jml_specification
      


