
(* This file was originally generated by why.
   It can be modified; only the generated parts will be overwritten. *)

Load "spec_imports".

Lemma mean1 : forall x y:Z, x <= y -> x <= (x + y) / 2.
Proof.
intros.
assert ((x + y) / 2 >= (x + x) / 2).
apply Z_div_ge; omega.
assert ((x + x) / 2 = x); auto with *.
replace (x + x) with (0 + x * 2); auto with *.
rewrite (Z_div_plus 0 x 2); auto with *.
Qed.

Lemma mean2 : forall x y:Z, x < y -> (x + y) / 2 < y.
Proof.
intros.
apply (Zmult_gt_0_lt_reg_r ((x + y) / 2) y 2).
auto with *.
replace ((x + y) / 2 * 2) with (2 * ((x + y) / 2)); auto with *.
assert (2 * ((x + y) / 2) <= x + y).
apply (Z_mult_div_ge (x + y) 2).
auto with *.
omega.
Qed.

Hint Resolve mean1 mean2.


(* Why obligation from file "IntSet_index.why", characters 859-889 *)
Lemma IntSet_index_body_po_1 : 
  forall (this: value),
  forall (n: Z),
  forall (heap: store),
  forall (intA: ((memarray) Z)),
  forall (t: ((memory) value)),
  forall (taille: ((memory) Z)),
  forall (Pre6: (neqv this Null) /\
                (instanceof heap this (ClassType IntSet)) /\
                (IntSet_invariant heap t taille intA this)),
  forall (m: Z),
  forall (Post9: m = 0),
  forall (b: Z),
  forall (Post8: b = (acc taille this)),
  forall (a: Z),
  forall (Post7: a = 0),
  forall (Variant1: Z),
  forall (a1: Z),
  forall (b1: Z),
  forall (Pre5: Variant1 = (b1 - a1)),
  forall (Pre4: (((0 <= a1 /\ a1 <= b1) /\ b1 <= (acc taille this)) /\
                (forall (i:Z),
                 (0 <= i /\ i < a1 -> (array_acc intA (acc t this) i) < n))) /\
                (forall (i:Z),
                 (b1 <= i /\ i < (acc taille this) ->
                  (array_acc intA (acc t this) i) >= n))),
  forall (Test4: a1 < b1),
  ~(2 = 0).
Proof.
intuition.
Qed.

(* Why obligation from file "IntSet_index.why", characters 901-1037 *)
Lemma IntSet_index_body_po_2 : 
  forall (this: value),
  forall (n: Z),
  forall (heap: store),
  forall (intA: ((memarray) Z)),
  forall (t: ((memory) value)),
  forall (taille: ((memory) Z)),
  forall (Pre6: (neqv this Null) /\
                (instanceof heap this (ClassType IntSet)) /\
                (IntSet_invariant heap t taille intA this)),
  forall (m: Z),
  forall (Post9: m = 0),
  forall (b: Z),
  forall (Post8: b = (acc taille this)),
  forall (a: Z),
  forall (Post7: a = 0),
  forall (Variant1: Z),
  forall (a1: Z),
  forall (b1: Z),
  forall (Pre5: Variant1 = (b1 - a1)),
  forall (Pre4: (((0 <= a1 /\ a1 <= b1) /\ b1 <= (acc taille this)) /\
                (forall (i:Z),
                 (0 <= i /\ i < a1 -> (array_acc intA (acc t this) i) < n))) /\
                (forall (i:Z),
                 (b1 <= i /\ i < (acc taille this) ->
                  (array_acc intA (acc t this) i) >= n))),
  forall (Test4: a1 < b1),
  forall (m2: Z),
  forall (Post2: m2 = ((Zdiv (a1 + b1) 2))),
  (is_valid_index heap (acc t this) m2).
Proof.
unfold IntSet_invariant; intros.
assert (a1 <= (a1 + b1) / 2); 
 assert ((a1 + b1) / 2 < b1); intuition.
Qed.

(* Why obligation from file "IntSet_index.why", characters 1050-1070 *)
Lemma IntSet_index_body_po_3 : 
  forall (this: value),
  forall (n: Z),
  forall (heap: store),
  forall (intA: ((memarray) Z)),
  forall (t: ((memory) value)),
  forall (taille: ((memory) Z)),
  forall (Pre6: (neqv this Null) /\
                (instanceof heap this (ClassType IntSet)) /\
                (IntSet_invariant heap t taille intA this)),
  forall (m: Z),
  forall (Post9: m = 0),
  forall (b: Z),
  forall (Post8: b = (acc taille this)),
  forall (a: Z),
  forall (Post7: a = 0),
  forall (Variant1: Z),
  forall (a1: Z),
  forall (b1: Z),
  forall (Pre5: Variant1 = (b1 - a1)),
  forall (Pre4: (((0 <= a1 /\ a1 <= b1) /\ b1 <= (acc taille this)) /\
                (forall (i:Z),
                 (0 <= i /\ i < a1 -> (array_acc intA (acc t this) i) < n))) /\
                (forall (i:Z),
                 (b1 <= i /\ i < (acc taille this) ->
                  (array_acc intA (acc t this) i) >= n))),
  forall (Test4: a1 < b1),
  forall (m2: Z),
  forall (Post2: m2 = ((Zdiv (a1 + b1) 2))),
  forall (Pre3: (is_valid_index heap (acc t this) m2)),
  forall (Test3: (array_acc intA (acc t this) m2) < n),
  forall (a2: Z),
  forall (Post4: a2 = (m2 + 1)),
  ((((0 <= a2 /\ a2 <= b1) /\ b1 <= (acc taille this)) /\
  (forall (i:Z), (0 <= i /\ i < a2 -> (array_acc intA (acc t this) i) < n))) /\
  (forall (i:Z),
   (b1 <= i /\ i < (acc taille this) -> (array_acc intA (acc t this) i) >= n))) /\
  (Zwf 0 (b1 - a2) (b1 - a1)).
Proof.
unfold IntSet_invariant; intros.
assert (a1 <= (a1 + b1) / 2); 
  assert ((a1 + b1) / 2 < b1); intuition.
assert ((intA:(this#t)[i]) <= (intA:(this#t)[m2])); 
  auto with *.
Qed.

(* Why obligation from file "IntSet_index.why", characters 1083-1089 *)
Lemma IntSet_index_body_po_4 : 
  forall (this: value),
  forall (n: Z),
  forall (heap: store),
  forall (intA: ((memarray) Z)),
  forall (t: ((memory) value)),
  forall (taille: ((memory) Z)),
  forall (Pre6: (neqv this Null) /\
                (instanceof heap this (ClassType IntSet)) /\
                (IntSet_invariant heap t taille intA this)),
  forall (m: Z),
  forall (Post9: m = 0),
  forall (b: Z),
  forall (Post8: b = (acc taille this)),
  forall (a: Z),
  forall (Post7: a = 0),
  forall (Variant1: Z),
  forall (a1: Z),
  forall (b1: Z),
  forall (Pre5: Variant1 = (b1 - a1)),
  forall (Pre4: (((0 <= a1 /\ a1 <= b1) /\ b1 <= (acc taille this)) /\
                (forall (i:Z),
                 (0 <= i /\ i < a1 -> (array_acc intA (acc t this) i) < n))) /\
                (forall (i:Z),
                 (b1 <= i /\ i < (acc taille this) ->
                  (array_acc intA (acc t this) i) >= n))),
  forall (Test4: a1 < b1),
  forall (m2: Z),
  forall (Post2: m2 = ((Zdiv (a1 + b1) 2))),
  forall (Pre3: (is_valid_index heap (acc t this) m2)),
  forall (Test2: (array_acc intA (acc t this) m2) >= n),
  forall (b2: Z),
  forall (Post3: b2 = m2),
  ((((0 <= a1 /\ a1 <= b2) /\ b2 <= (acc taille this)) /\
  (forall (i:Z), (0 <= i /\ i < a1 -> (array_acc intA (acc t this) i) < n))) /\
  (forall (i:Z),
   (b2 <= i /\ i < (acc taille this) -> (array_acc intA (acc t this) i) >= n))) /\
  (Zwf 0 (b2 - a1) (b1 - a1)).
Proof.
unfold IntSet_invariant; intros.
assert (a1 <= (a1 + b1) / 2); 
  assert ((a1 + b1) / 2 < b1); intuition.
assert ((intA:(this#t)[m2]) <= (intA:(this#t)[i])); auto with *.
Qed.

(* Why obligation from file "IntSet_index.why", characters 397-1096 *)
Lemma IntSet_index_body_po_5 : 
  forall (this: value),
  forall (n: Z),
  forall (heap: store),
  forall (intA: ((memarray) Z)),
  forall (t: ((memory) value)),
  forall (taille: ((memory) Z)),
  forall (Pre6: (neqv this Null) /\
                (instanceof heap this (ClassType IntSet)) /\
                (IntSet_invariant heap t taille intA this)),
  forall (m: Z),
  forall (Post9: m = 0),
  forall (b: Z),
  forall (Post8: b = (acc taille this)),
  forall (a: Z),
  forall (Post7: a = 0),
  forall (Variant1: Z),
  forall (a1: Z),
  forall (b1: Z),
  forall (Pre5: Variant1 = (b1 - a1)),
  forall (Pre4: (((0 <= a1 /\ a1 <= b1) /\ b1 <= (acc taille this)) /\
                (forall (i:Z),
                 (0 <= i /\ i < a1 -> (array_acc intA (acc t this) i) < n))) /\
                (forall (i:Z),
                 (b1 <= i /\ i < (acc taille this) ->
                  (array_acc intA (acc t this) i) >= n))),
  forall (Test1: a1 >= b1),
  (forall (result:Z),
   (result = a1 -> ((0 <= result /\ result <= (acc taille this)) /\
    (forall (i:Z),
     (0 <= i /\ i < result -> (array_acc intA (acc t this) i) < n))) /\
    (forall (i:Z),
     (result <= i /\ i < (acc taille this) ->
      (array_acc intA (acc t this) i) >= n)))).
Proof.
unfold IntSet_invariant; intuition.
Qed.



(* Why obligation from file "IntSet_index.why", characters 449-815 *)
Lemma IntSet_index_body_po_6 : 
  forall (this: value),
  forall (n: Z),
  forall (heap: store),
  forall (intA: ((memarray) Z)),
  forall (t: ((memory) value)),
  forall (taille: ((memory) Z)),
  forall (Pre6: (neqv this Null) /\
                (instanceof heap this (ClassType IntSet)) /\
                (IntSet_invariant heap t taille intA this)),
  forall (m: Z),
  forall (Post9: m = 0),
  forall (b: Z),
  forall (Post8: b = (acc taille this)),
  forall (a: Z),
  forall (Post7: a = 0),
  (((0 <= a /\ a <= b) /\ b <= (acc taille this)) /\
  (forall (i:Z), (0 <= i /\ i < a -> (array_acc intA (acc t this) i) < n))) /\
  (forall (i:Z),
   (b <= i /\ i < (acc taille this) -> (array_acc intA (acc t this) i) >= n)).
Proof.
unfold IntSet_invariant; intuition.
Save.

