
package tutorial;

public class Lesson1 {

    /*@ public normal_behavior
      @   ensures \result >= x && \result >= y &&
      @    (\forall int z; z>=x && z>=y ; z>=\result);
      @*/
    public static int max(int x, int y) {
	if (x>y) return x; else  return y; 
    }
    
    /*@ public normal_behavior
      @   requires x >= 0;
      @   ensures 
      @      \result >=0 && \result * \result <= x 
      @      && x < (\result + 1) * (\result + 1);
      @*/
    public static int sqrt(int x) {
	int count = 0, sum = 1;
	/*@ loop_invariant 
	  @   count >= 0 && x >= count*count &&
          @   sum == (count+1)*(count+1);
	  @ decreases x - sum;
	  @*/
	while (sum <= x) { 
	    count++;
	    sum = sum + 2*count+1;
	}
	return count;
    }   


    /*@ public normal_behavior
      @   ensures \result == x*x ;
      @*/
    public static /*@ pure @*/ int sqr(int x) {
	return x*x;
    }   
    

    /*@ public normal_behavior
      @   requires x >= 0;
      @   ensures 
      @      \result >=0 && sqr(\result) <= x 
      @      && x < sqr(\result + 1);
      @*/
    public static int sqrt2(int x) {
	int count = 0, sum = 1;
	/*@ loop_invariant 
	  @   count >= 0 && x >= sqr(count) &&
          @   sum == sqr(count+1);
	  @ decreases x - sum;
	  @*/
	while (sum <= x) { 
	    count++;
	    sum = sum + 2*count+1;
	}
	return count;
    }   


    
}
