

exception Typing_error of string;;

exception Ill_typed of string;;

val ill_typed : Location.t -> string -> 'a;;

(*

   [initial_env ()] returns the initial environment, as given by
   KRAKATOAPATH variable and additional path given by user using -I
   option (see [Config.input_path])

*)

val initial_env : unit -> Java_context_types.t;;

(*

  phase1 traverses a compilation unit and return the java environment
  augmented with visible packages, classes and/or interfaces.

*)

  
val phase1 : 
     Java_context_types.t -> string -> Ast_types.compilation_unit 
       -> Ast_types.compilation_unit * Java_context_types.t;;

val phase1_imported_files : Java_context_types.t -> Java_context_types.t;;


(*

  phase2 traverses a compilation unit and adds ; in the java
  environment of visible packages, classes and interfaces ; fields
  and methods of classes and interfaces.


*)


val phase2 : 
  Java_context_types.t -> string -> Ast_types.compilation_unit 
    -> Ast_types.compilation_unit
;; 

val additional_files_to_type : (string * Ast_types.compilation_unit) list ref;;
 

val constructor_overloading : Java_context_types.t -> unit;;

(*

  phase3 traverses a non-typed compilation unit and returns a typed one.

*)


val phase3 :
  Java_context_types.t -> string -> Ast_types.compilation_unit 
    -> Ast_types.compilation_unit
;; 



