
Require Export preambule.
Require Export classes.
Require Export global_memory.
Require Export ZArith.


Module DummyClasses.

(* Classes *)

Inductive classIdI : Set :=
    Object : classIdI.
Definition classId := classIdI.

Definition ObjectClass := Object.

Definition eq_classId_dec : forall i1 i2:classId, {i1 = i2} + {i1 <> i2}.
decide equality. Defined.

Definition super (i:classId) : option classId :=
  match i with
  | Object => None
  end.

Lemma superObject : super ObjectClass = None.
auto. Qed.

Lemma wf_Object : Acc (fun i1 i2 => def (super i2) i1) Object.
constructor; simpl in |- *; intros.
case (undef_not_def (A:=classId) (x:=None)) with y; auto.
Defined.


Lemma super_wf : well_founded (fun i1 i2 => def (super i2) i1).
red in |- *; intros.
case a.
apply wf_Object.
Defined.

(* fields *)

Inductive fieldIdI : Set :=.

Definition fieldId := fieldIdI.

Definition eq_fieldId_dec : forall f1 f2:fieldId, {f1 = f2} + {f1 <> f2}.
Proof. decide equality. Defined.

Definition defined_in (f:fieldId) : classId := match f with
                                               end.

Lemma no_field_in_Object : forall f:fieldId, defined_in f <> ObjectClass.
Proof. simple induction f; auto. Qed.

(* types of fields *)

Definition fieldT (f:fieldId) : javaT classId := match f with
                                                 end.

End DummyClasses.

Import DummyClasses.
Module DummyObj := ObjectAdr DummyClasses.
Module DummyGen := DummyObj.CGen.

Export DummyClasses.
Export DummyObj.
Export DummyGen.
Export CGen.